--------------------------------------
---- Raeli's Spell Announcer Core ----
--------------------------------------
RSA = LibStub("AceAddon-3.0"):NewAddon("RSA", "AceConsole-3.0") -- , "LibSink-2.0"
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")

------------------
---- Defaults ----
------------------
local defaults = {
	global = {
		--version = GetAddOnMetadata("RSA", "Version")	
	},
	profile = {
		General = {
			Class = "",
			Smart = {
				RaidParty = true,
				Say = false,
				CustomChannel = true,
				InInstance = true,
				PvP = true,
			},
			Local = {
				RaidWarn = true,
				Chat = true,
				--[[ Keep these like this for now. Need to research more about these and how to do this.
				MSBT = false,
				MSBT_Area = "",
				BW = "",
				DBM = "",
				]]--
			},
			GlobalCustomChannel = "MyCustomChannel",
		},
		Reminders = {
			DisableInPvP = true,
			EnableInSpec1 = true,
			EnableInSpec2 = false,
			ScrollWheel = {
				Enabled = false,
				WheelUp = "",
				WheelDown = "",
			},
			CheckInterval = 10,
			RemindInterval = 15,
			RemindChannels = {
				Chat = true,
				RaidWarn = true,
				--[[ Keep these like this for now. Need to research more about these and how to do this.
				MSBT = "",
				BW = "",
				DBM = "",
				]]--
			},
		},


		DeathKnight = {
			Reminders = {
				SpellName = "",
			},
			Spells = {
				Army = {
					Messages = {
						Start = "Casting LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				AMS = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				DarkCommand = {
					Messages = {
						Start = "Taunted TARGET!",
						End = "TARGET MISSTYPE my Taunt!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				IceboundFortitude = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Strangulate = {
					Messages = {
						Start = "Strangulated TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARTET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				DeathGrip = {
					Messages = {
						Start = "Death Gripped TARGET!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				VampiricBlood = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				BoneShield = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
			},
		},
		Druid = {
			Reminders = {
				SpellName = "",
			},
			Spells = {
				SurvivalInstincts = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Cyclone = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
						Immune = "LINK MISSTYPE on TARGET!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End					
				FrenziedRegeneration = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Hibernate = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
						Immune = "LINK MISSTYPE on TARGET!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End					
				Innervate = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				SkullBash = {
					Messages = {
						Start = "Interrupted TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Growl = {
					Messages = {
						Start = "Taunted TARGET!",
						End = "TARGET MISSTYPE my Taunt!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End			
				
			},
		},
		Hunter = {
			Reminders = {
				SpellName = "",
			},
		},
		Mage = {
			Reminders = {
				SpellName = "Molten Armor",
			},
			Spells = {
				TimeWarp = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Spellsteal = {
					Messages = {
						Start = "Stole TARGET's AURA!",
						End = "TARGET resisted LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Polymorph = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
						Immune = "LINK MISSTYPE on TARGET!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End			
				Counterspell = {
					Messages = {
						Start = "Counterspelled TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARTET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Portals = {
					Messages = {
						Start = "Casting LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Teleport = {
					Messages = {
						Start = "Warning you are Teleporting, and leaving your friends behind!",
					},
					Local = true,
				}, -- End				
				RefreshmentTable = {
					Messages = {
						Start = "Casting LINK, please assist!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
			
			},
		},
		Paladin = {
			Reminders = {
				SpellName = "Righteous Fury",
			},
			Spells = {
				ArdentDefender = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				AuraMastery = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				DivineProtection = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Forbearance = {
					Messages = {
						Start = "",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--[[Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},]]--
				}, -- End
				DivineGuardian = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				HandOfFreedom = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = true,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End
				HandOfProtection = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = true,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End
				HandOfSacrifice = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = true,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End
				HandOfSalvation = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = true,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End
				LayOnHands = {
					Messages = {
						Start = "LINK on TARGET for AMOUNT!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				GoAK = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Repentance = {
					Messages = {
						Start = "LINK on TARGET!",
						End = "LINK on TARGET has ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Rebuke = {
					Messages = {
						Start = "Interrupted TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				HandOfReckoning = {
					Messages = {
						Start = "Taunted TARGET!",
						End = "TARGET MISSTYPE my Taunt!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				RighteousDefense = {
					Messages = {
						Start = "Taunted TARGET!",
						End = "TARGET MISSTYPE my Taunt!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Beacon = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET has ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				HammerOfJustice = {
					Messages = {
						Start = "Interrupted TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				
			},
		},
		Priest = {
			Reminders = {
				SpellName = "Inner Fire",
			},
			Spells = {
				LeapOfFaith = {
					Messages = {
						Start = "Pulling TARGET to Me!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = true,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End
				DivineHymn = {
					Messages = {
						Start = "LINK activated!",
						End = "LINK over!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				HymnOfHope = {
					Messages = {
						Start = "LINK activated!",
						End = "LINK over!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				FearWard = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = true,
					Whisper = true,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End
				Levitate = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = true,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End	
				ShackleUndead = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
						Immune = "LINK MISSTYPE on TARGET!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End		
				DispelMagic = {
					Messages = {
						Start = "Dispelled AURA on TARGET!",
						End = "TARGET resisted LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End	
				GuardianSpirit = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End	
				PainSuppression = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End			
				Lightwell = {
					Messages = {
						Start = "LINK activated!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End	
				PowerInfusion = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				
			},
		},
		Rogue = {
			Reminders = {
				SpellName = "",
			},
		},
		Shaman = {
			Reminders = {
				SpellName = "",
			},
			Spells = {
				Hex = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End					
				Heroism = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End					
				BindElemental = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "LINK on TARGET ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End					
				WindShear = {
					Messages = {
						Start = "Interrupted TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARTET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Purge = {
					Messages = {
						Start = "Purged TARGET's AURA!",
						End = "TARGET resisted LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				ManaTide = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
			},
		},
		Warlock = {
			Reminders = {
				SpellName = "Fel Armor",
			},
			Spells = {
				SoulWell = {
					Messages = {
						Start = "Casting LINK, please assist!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				SummonStone = {
					Messages = {
						Start = "Casting LINK, please assist!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Suffering = {
					Messages = {
						Start = "Taunted TARGET!",
						End = "TARGET MISSTYPE my Taunt!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = true,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End
				SingeMagic = {
					Messages = {
						Start = "LINK on TARGET removed AURA!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = true,
					--Whisper = false,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End
				Banish = {
					Messages = {
						Start = "Banished TARGET!",
						End = "LINK on TARGET has ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Fear = {
					Messages = {
						Start = "Fearing TARGET!",
						End = "LINK on TARGET has ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Seduce = {
					Messages = {
						Start = "Seducing TARGET!",
						End = "LINK on TARGET has ended!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				SpellLock = {
					Messages = {
						Start = "Spell Locked TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARTET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End
				Devour = {
					Messages = {
						Start = "Devoured TARGET's AURA!",
						End = "TARGET resisted LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End

			}, -- End Spells
		}, -- End Warlock
		Warrior = {
			Reminders = {
				SpellName = "",
			},
			Spells = {			
				ShatteringThrow = {
					Messages = {
						Start = "LINK on TARGET!",
						End = "LINK on TARGET Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				ShieldWall = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				ChallengingShout = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Pummel = {
					Messages = {
						Start = "Pummeled TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARTET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Disarm = {
					Messages = {
						Start = "Disarmed TARGET!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				ShieldBlock = {
					Messages = {
						Start = "",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = true,
					--Whisper = false,
					Raid = false,
					Party = false,
					Smart = {
						RaidParty = false,
						Say = false,
					},
				}, -- End				
				ShieldBash = {
					Messages = {
						Start = "Shield Bashed TARGET's TARCAST!",
						End = "My LINK MISSTYPE TARGET!",
						Immune = "TARTET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Taunt = {
					Messages = {
						Start = "Taunted TARGET!",
						End = "TARGET MISSTYPE my Taunt!",
						Immune = "TARGET is MISSTYPE to my LINK!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				Vigilance = {
					Messages = {
						Start = "LINK cast on TARGET!",
						End = "",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
				LastStand = {
					Messages = {
						Start = "LINK Activated!",
						End = "LINK Faded!",
					},
					CustomChannel = {
						Enabled = false,
						Channel = "",
					},
					Local = false,
					--Whisper = false,
					Raid = true,
					Party = true,
					Smart = {
						RaidParty = true,
						Say = false,
					},
				}, -- End				
			}, 
		},
	}, -- End Profile
} -- End Defaults

-----------------------
---- Ace functions ----
-----------------------
function RSA:OnInitialize()
	-- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("RSADB", defaults) -- Setup Saved Variables
	
	-- Check what class we are and save it. Used to determine what options to show.
	local pClass = select(2, UnitClass("player"))
	self.db.profile.General.Class = pClass
	
	-- Register /RSA command
	self:RegisterChatCommand("RSA", "ChatCommand")
	
	
end

function RSA:RefreshConfig()
	local pClass = select(2, UnitClass("player"))
		self.db.profile.class = pClass
end

function RSA:OnProfileEnable()
	self.db = self.db.profile
	local pClass = select(2, UnitClass("player"))
		self.db.profile.class = pClass
end

function RSA:ChatCommand(input)
	local loaded, reason = LoadAddOn("RSA_Options")
	if not loaded then
		if reason == "DISABLED" or reason == "INTERFACE_VERSION" then
			ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. L.OptionsDisabled)
		elseif reason == "MISSING" or reason == "CORRUPT" then
			ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. L.OptionsMissing)
		end
	else
		InterfaceOptionsFrame_OpenToCategory("Raeli's Spell Announcer")
	end
end

--------------------------------
---- Announcement Functions ----
--------------------------------
local function Print_Self(message) -- Send a message to your default chat window.
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. format(message))
end

local function Print_Raid_Smart(message) -- Send a message to raid, party, or nothing, depending on group size.
	local InInstance, InstanceType = IsInInstance()
	if (RSA.db.profile.General.Smart.InInstance == true and InInstance == 1) or (RSA.db.profile.General.Smart.InInstance == false) and (RSA.db.profile.General.Smart.PvP == true and UnitIsPVP("player") ~= 1) or (RSA.db.profile.General.Smart.PvP == false) then
		if GetNumRaidMembers() > 0 then
			SendChatMessage(format(message), "RAID", nil)
		elseif GetNumPartyMembers() > 0 then
			SendChatMessage(format(message), "PARTY", nil)
		end
	end
end

local function Print_Raid(message) -- Send a message to raid or nothing.
	local InInstance, InstanceType = IsInInstance()
	if ((RSA.db.profile.General.Smart.InInstance == true and InInstance == 1) or (RSA.db.profile.General.Smart.InInstance == false)) and ((RSA.db.profile.General.Smart.PvP == true and UnitIsPVP("player") ~= 1) or (RSA.db.profile.General.Smart.PvP == false)) then
		if GetNumRaidMembers() > 0 then
			SendChatMessage(format(message), "RAID", nil)
		end
	end
end

local function Print_Party(message) -- Send a message to party or nothing.
	local InInstance, InstanceType = IsInInstance()
	if ((RSA.db.profile.General.Smart.InInstance == true and InInstance == 1) or (RSA.db.profile.General.Smart.InInstance == false)) and ((RSA.db.profile.General.Smart.PvP == true and UnitIsPVP("player") ~= 1) or (RSA.db.profile.General.Smart.PvP == false)) then
		if GetNumPartyMembers() > 0 and GetNumRaidMembers() == 0 then
			SendChatMessage(format(message), "PARTY", nil)
		end
	end
end

local function Print_Channel(message, channel) -- Send a message to the custom channel that the user defines.
	local InInstance, InstanceType = IsInInstance()
	if ((RSA.db.profile.General.Smart.InInstance == true and InInstance == 1) or (RSA.db.profile.General.Smart.InInstance == false)) and ((RSA.db.profile.General.Smart.PvP == true and UnitIsPVP("player") ~= 1) or (RSA.db.profile.General.Smart.PvP == false)) then
		if RSA.db.profile.General.Smart.CustomChannel == true then
			if GetNumRaidMembers()>0 or GetNumPartyMembers()>0 then
				SendChatMessage(format(message), "CHANNEL", nil, GetChannelName(channel))
			end
		elseif RSA.db.profile.General.Smart.CustomChannel == false then
				SendChatMessage(format(message), "CHANNEL", nil, GetChannelName(channel))			
		end
	end
end

local function Print_Self_RW(message) -- Send a message locally to the raid warning frame. Only visible to the user.
	local RWColor = {r=1, g=1, b=1}
	RaidNotice_AddMessage(RaidWarningFrame, "|cFFFF75B3RSA:|r " .. format(message), RWColor)
end

local function Print_RW(message) -- Send a proper message to the raid warning frame.
	local InInstance, InstanceType = IsInInstance()
	if ((RSA.db.profile.General.Smart.InInstance == true and InInstance == 1) or (RSA.db.profile.General.Smart.InInstance == false)) and ((RSA.db.profile.General.Smart.PvP == true and UnitIsPVP("player") ~= 1) or (RSA.db.profile.General.Smart.PvP == false)) then
		SendChatMessage(format(message), "RAID_WARNING", nil)
	end	
end

local function Print_Whisper(message, target) -- Send a whisper to the target.
	SendChatMessage(format(message), "WHISPER", nil, target)
end

local function Print_Say(message) -- Send a message to Say.
	local InInstance, InstanceType = IsInInstance()
	if ((RSA.db.profile.General.Smart.InInstance == true and InInstance == 1) or (RSA.db.profile.General.Smart.InInstance == false)) and ((RSA.db.profile.General.Smart.PvP == true and UnitIsPVP("player") ~= 1) or (RSA.db.profile.General.Smart.PvP == false)) then
		if RSA.db.profile.General.Smart.Say == true then
			if GetNumRaidMembers() > 0 and GetNumPartyMembers() > 0 then
				SendChatMessage(format(message), "SAY", nil)
			end
		elseif RSA.db.profile.General.Smart.Say == false then
			SendChatMessage(format(message), "SAY", nil)
		end
	end		
end

-----------------------------
---- Combat Log Checking ----
-----------------------------
local CombatLogMonitor = CreateFrame("Frame", "RSA:CLM")
local pName = UnitName("player")
function RSA_String_Replace(str)
	return RSA_Replacements [str] or str
end
CombatLogMonitor:SetScript("OnEvent", function(_, _, _, event, _, source, _, _, dest, _, spellID, spellName, _, missType)
	local petName = UnitName("pet")
	if source == pName or source == petName then
	
--		Death Knights Druid Hunter Mage Paladin Priest Rogue Shaman Warlock Warrior

		if event == "SPELL_AURA_APPLIED" then		
			-- Reminder Refreshed
			if RSA.db.profile.General.Class == "DEATHKNIGHT" then -- Check Class, Set the Spell we're reminding about.
				ReminderSpell = RSA.db.profile.DeathKnight.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "DRUID" then
				ReminderSpell = RSA.db.profile.Druid.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "HUNTER" then
				ReminderSpell = RSA.db.profile.Hunter.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "MAGE" then
				ReminderSpell = RSA.db.profile.Mage.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "PALADIN" then
				ReminderSpell = RSA.db.profile.Paladin.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "PRIEST" then
				ReminderSpell = RSA.db.profile.Priest.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "ROGUE" then
				ReminderSpell = RSA.db.profile.Rogue.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "SHAMAN" then
				ReminderSpell = RSA.db.profile.Shaman.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "WARLOCK" then
				ReminderSpell = RSA.db.profile.Warlock.Reminders.SpellName
			elseif RSA.db.profile.General.Class == "WARRIOR" then
				ReminderSpell = RSA.db.profile.Warrior.Reminders.SpellName
			end
			if spellName == ReminderSpell and dest == pName then
				RSA_Reminder:SetScript("OnUpdate", nil)
				if RSA.db.profile.Reminders.RemindChannels.Chat == true then
					Print_Self(ReminderSpell .. " Refreshed!")
				end
				if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
					Print_Self_RW(ReminderSpell .. " Refreshed!")
				end
			end
			
			
			-- MAGE
			if spellID == 118 or spellID == 61305 or spellID == 28272 or spellID == 61721 or spellID == 61780 or spellID == 28271 then -- POLYMORPH
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Mage.Spells.Polymorph.Messages.Start ~= "" then
					if RSA.db.profile.Mage.Spells.Polymorph.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.Polymorph.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.Polymorph.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.Polymorph.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.Polymorph.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.Polymorph.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.Polymorph.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- POLYMORPH	
			if spellID == 80353 then -- TIME WARP
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start ~= "" then
					if RSA.db.profile.Mage.Spells.TimeWarp.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.TimeWarp.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Mage.Spells.TimeWarp.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.TimeWarp.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.TimeWarp.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.TimeWarp.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.TimeWarp.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.TimeWarp.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.TimeWarp.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- TIME WARP			
			
			-- PALADIN
			if spellID == 62124 then -- HAND OF RECKONING
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfReckoning.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Start, "%a+", RSA_String_Replace))
						end
					end

				end
			end -- HAND OF RECKONING
			if spellID == 31790 then -- RIGHTEOUS DEFENSE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.RighteousDefense.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- RIGHTEOUS DEFENSE	
			if spellID == 70940 and dest == pName then -- DIVINE GUARDIAN
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.DivineGuardian.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.DivineGuardian.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.DivineGuardian.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.DivineGuardian.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.DivineGuardian.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.DivineGuardian.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.DivineGuardian.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.DivineGuardian.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DIVINE GUARDIAN		
			if spellID == 86150 or spellID == 86657 or spellID == 86674 or spellID == 86701 then -- GUARDIAN OF ANCIENT KINGS
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.GoAK.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.GoAK.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.GoAK.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.GoAK.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.GoAK.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.GoAK.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.GoAK.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.GoAK.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.GoAK.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- GUARDIAN OF ANCIENT KINGS
			if spellID == 25771 then -- FORBEARANCE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.Forbearance.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.Forbearance.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.Forbearance.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Forbearance.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Forbearance.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Forbearance.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Forbearance.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Forbearance.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- FORBEARANCE			

			--PRIEST
			if spellID == 9484 then -- SHACKLE UNDEAD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.ShackleUndead.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.ShackleUndead.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.ShackleUndead.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.ShackleUndead.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.ShackleUndead.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.ShackleUndead.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.ShackleUndead.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SHACKLE UNDEAD					
			
			-- WARLOCK
			if spellID == 17735 then -- SUFFERING
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.Suffering.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.Suffering.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Suffering.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Suffering.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Suffering.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Suffering.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Suffering.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Suffering.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Start, "%a+", RSA_String_Replace))
						end
					end

				end
			end -- SUFFERING
			if spellID == 18647 then -- BANISH
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.Banish.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.Banish.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Banish.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Banish.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Banish.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Banish.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Banish.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Banish.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- BANISH			
			if spellID == 5782 then -- FEAR
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.Fear.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.Fear.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Fear.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Fear.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Fear.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Fear.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Fear.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Fear.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- FEAR
			if spellID == 6358 then -- SEDUCE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.Seduce.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.Seduce.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Seduce.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Seduce.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Seduce.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Seduce.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Seduce.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Seduce.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SEDUCE				
			
		end -- IF EVENT IS SPELL_AURA_APPLIED
		
		
		if event == "SPELL_CAST_START" then
			-- MAGE
			if spellID == 53142 or spellID == 11419 or spellID == 32266 or spellID == 11416 or spellID == 11417 -- PORTALS
			or spellID == 35717 or spellID == 33691 or spellID == 32267 or spellID == 49361 or spellID == 10059
			or spellID == 49360 or spellID == 11420 or spellID == 11418 then
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Mage.Spells.Portals.Messages.Start ~= "" then
					if RSA.db.profile.Mage.Spells.Portals.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Portals.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Portals.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.Portals.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Mage.Spells.Portals.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Mage.Spells.Portals.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.Portals.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.Portals.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.Portals.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.Portals.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.Portals.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.Portals.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.Portals.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.Portals.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.Portals.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.Portals.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- PORTALS
			if spellID == 53140 or spellID == 3562 or spellID == 32271 or spellID == 3562 or spellID == 3567 -- TELEPORTS
			or spellID == 33690 or spellID == 35715 or spellID == 32272 or spellID == 49358 or spellID == 3561
			or spellID == 49359 or spellID == 3566 or spellID == 3563 then
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Mage.Spells.Teleport.Messages.Start ~= "" then
					if RSA.db.profile.Mage.Spells.Teleport.Local == true and (GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0) then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Teleport.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Teleport.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- TELEPORT			
		
		end -- IF EVENT IS SPELL_CAST_START
		
		
		if event == "SPELL_CAST_SUCCESS" then
			-- MAGE
			if spellID == 43987 then -- REFRESHMENT TABLE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start ~= "" then
					if RSA.db.profile.Mage.Spells.RefreshmentTable.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.RefreshmentTable.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Mage.Spells.RefreshmentTable.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.RefreshmentTable.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.RefreshmentTable.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.RefreshmentTable.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.RefreshmentTable.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.RefreshmentTable.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.RefreshmentTable.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- REFRESHMENT TABLE			
			
			-- PALADIN
			if spellID == 31850 then -- ARDENT DEFENDER
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.ArdentDefender.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.ArdentDefender.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.ArdentDefender.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.ArdentDefender.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.ArdentDefender.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.ArdentDefender.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.ArdentDefender.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.ArdentDefender.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- ARDENT DEFENDER
			if spellID == 31821 then -- AURA MASTERY
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.AuraMastery.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.AuraMastery.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.AuraMastery.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.AuraMastery.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.AuraMastery.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.AuraMastery.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.AuraMastery.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.AuraMastery.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- AURA MASTERY
			if spellID == 498 then -- DIVINE PROTECTION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.DivineProtection.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.DivineProtection.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.DivineProtection.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.DivineProtection.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.DivineProtection.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.DivineProtection.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.DivineProtection.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.DivineProtection.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DIVINE PROTECTION
			if spellID == 1044 then -- HAND OF FREEDOM
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfFreedom.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfFreedom.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.HandOfFreedom.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfFreedom.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfFreedom.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfFreedom.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfFreedom.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfFreedom.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HAND OF FREEDOM
			if spellID == 1022 then -- HAND OF PROTECTION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfProtection.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfProtection.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.HandOfProtection.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfProtection.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfProtection.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfProtection.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfProtection.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfProtection.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HAND OF PROTECTION
			if spellID == 6940 then -- HAND OF SACRIFICE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.HandOfSacrifice.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfSacrifice.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HAND OF SACRIFICE
			if spellID == 1038 then -- HAND OF SALVATION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfSalvation.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfSalvation.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.HandOfSalvation.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfSalvation.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfSalvation.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfSalvation.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfSalvation.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfSalvation.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HAND OF SALVATION
			if spellID == 20066 then -- REPENTANCE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.Repentance.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.Repentance.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.Repentance.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.Repentance.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Repentance.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Repentance.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Repentance.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Repentance.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Repentance.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- REPENTANCE
			if spellID == 53563 then -- BEACON OF LIGHT
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.Beacon.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.Beacon.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.Beacon.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.Beacon.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Beacon.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Beacon.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Beacon.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Beacon.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Beacon.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- BEACON OF LIGHT

			-- PRIEST
			if spellID == 73325 then -- LEAP OF FAITH
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.LeapOfFaith.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.LeapOfFaith.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.LeapOfFaith.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.LeapOfFaith.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.LeapOfFaith.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.LeapOfFaith.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.LeapOfFaith.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.LeapOfFaith.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.LeapOfFaith.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- LEAP OF FAITH
			if spellID == 64843 then -- DIVINE HYMN
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.DivineHymn.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.DivineHymn.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.DivineHymn.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.DivineHymn.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.DivineHymn.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DIVINE HYMN
			if spellID == 64901 then -- HYMN OF HOPE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.HymnOfHope.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.HymnOfHope.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.HymnOfHope.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.HymnOfHope.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.HymnOfHope.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HYMN OF HOPE	
			if spellID == 6346 then -- FEAR WARD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.FearWard.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.FearWard.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.FearWard.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.FearWard.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.FearWard.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.FearWard.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.FearWard.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.FearWard.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.FearWard.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- FEAR WARD
			if spellID == 1706 then -- LEVITATE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.Levitate.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.Levitate.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.Levitate.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.Levitate.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.Levitate.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.Levitate.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.Levitate.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.Levitate.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.Levitate.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- LEVITATE			
			if spellID == 47788 then -- GUARDIAN SPIRIT
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.GuardianSpirit.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- GUARDIAN SPIRIT			
			if spellID == 33206 then -- PAIN SUPPRESSION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.PainSuppression.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.PainSuppression.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PainSuppression.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PainSuppression.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PainSuppression.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- PAIN SUPPRESSION			
			if spellID == 10060 then -- POWER INFUSION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.PowerInfusion.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.PowerInfusion.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PowerInfusion.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PowerInfusion.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PowerInfusion.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- POWER INFUSION			
			
			-- WARLOCK
			if spellID == 58887 then -- SOUL WELL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.SoulWell.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.SoulWell.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Warlock.Spells.SoulWell.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.SoulWell.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.SoulWell.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.SoulWell.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.SoulWell.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.SoulWell.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.SoulWell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SOUL WELL
			if spellID == 698 then -- SUMMONING STONE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.SummonStone.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.SummonStone.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Warlock.Spells.SummonStone.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.SummonStone.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.SummonStone.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.SummonStone.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.SummonStone.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.SummonStone.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.SummonStone.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SUMMONING STONE					
		
		end -- IF EVENT IS SPELL_CAST_SUCCESS
		
		
		if event == "SPELL_SUMMON" then		
			-- PRIEST
			if spellID == 724 then -- LIGHTWELL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.Lightwell.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.Lightwell.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.Lightwell.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Priest.Spells.Lightwell.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.Lightwell.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.Lightwell.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.Lightwell.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.Lightwell.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.Lightwell.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.Lightwell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- LIGHTWELL	
		
		end -- IF EVENT IS SPELL_SUMMON
		
		
		if event == "SPELL_INTERRUPT" then
			-- MAGE
			if spellID == 2139 then -- COUNTERSPELL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["TARCAST"] = extraspellinfo,}
				if RSA.db.profile.Mage.Spells.Counterspell.Messages.Start ~= "" then
					if RSA.db.profile.Mage.Spells.Counterspell.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.Counterspell.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.Counterspell.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.Counterspell.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.Counterspell.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.Counterspell.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.Counterspell.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- COUNTERSPELL			
			
			-- PALADIN
			if spellID == 85285 then -- REBUKE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["TARCAST"] = extraspellinfo,}
				if RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.Rebuke.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Rebuke.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Rebuke.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Rebuke.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Rebuke.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- REBUKE

			-- WARLOCK
			if spellID == 19647 then -- SPELL LOCK
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["TARCAST"] = extraspellinfo,}
				if RSA.db.profile.Warlock.Spells.SpellLock.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.SpellLock.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.SpellLock.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.SpellLock.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.SpellLock.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.SpellLock.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.SpellLock.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.SpellLock.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SPELL LOCK

		end -- IF EVENT IS SPELL_INTERRUPT
		
		
		if event == "SPELL_HEAL" then
			if spellID == 633 then -- LAY ON HANDS
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AMOUNT"] = missType,}
				if RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start ~= "" then
					if RSA.db.profile.Paladin.Spells.LayOnHands.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.LayOnHands.Whisper == true and dest ~= pName  then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You", ["AMOUNT"] = missType,}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "dest", ["AMOUNT"] = missType,}
					end
					if RSA.db.profile.Paladin.Spells.LayOnHands.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.LayOnHands.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.LayOnHands.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.LayOnHands.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.LayOnHands.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.LayOnHands.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.LayOnHands.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- LAY ON HANDS

		end -- IF EVENT IS SPELL_HEAL
		
		
		if event == "SPELL_AURA_REMOVED" then
			-- MAGE
			if spellID == 118 or spellID == 61305 or spellID == 28272 or spellID == 61721 or spellID == 61780 or spellID == 28271 then -- POLYMORPH
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Mage.Spells.Polymorph.Messages.End ~= "" then
					if RSA.db.profile.Mage.Spells.Polymorph.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.Polymorph.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.Polymorph.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.Polymorph.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.Polymorph.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.Polymorph.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.Polymorph.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.Polymorph.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- POLYMORPH
			
			-- PALADIN
			if spellID == 31850 then -- ARDENT DEFENDER
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.ArdentDefender.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.ArdentDefender.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.ArdentDefender.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.ArdentDefender.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.ArdentDefender.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.ArdentDefender.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.ArdentDefender.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.ArdentDefender.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.ArdentDefender.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- ARDENT DEFENDER
			if spellID == 31821 then -- AURA MASTERY
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.AuraMastery.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.AuraMastery.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.AuraMastery.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.AuraMastery.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.AuraMastery.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.AuraMastery.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.AuraMastery.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.AuraMastery.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.AuraMastery.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- AURA MASTERY
			if spellID == 498 then -- DIVINE PROTECTION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.DivineProtection.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.DivineProtection.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.DivineProtection.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.DivineProtection.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.DivineProtection.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.DivineProtection.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.DivineProtection.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.DivineProtection.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.DivineProtection.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DIVINE PROTECTION
			if spellID == 25771 and dest == pName then -- FORBEARANCE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.Forbearance.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.Forbearance.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					--[[if RSA.db.profile.Paladin.Spells.Forbearance.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.Forbearance.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Forbearance.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Forbearance.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Forbearance.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Forbearance.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Forbearance.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Forbearance.Messages.End, "%a+", RSA_String_Replace))
						end
					end]]--
				end
			end -- FORBEARANCE
			if spellID == 70940 and dest == pName then -- DIVINE GUARDIAN
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.DivineGuardian.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.DivineGuardian.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.DivineGuardian.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.DivineGuardian.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.DivineGuardian.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.DivineGuardian.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.DivineGuardian.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.DivineGuardian.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.DivineGuardian.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DIVINE GUARDIAN
			if spellID == 1044 then -- HAND OF FREEDOM
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfFreedom.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfFreedom.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.HandOfFreedom.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfFreedom.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfFreedom.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfFreedom.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfFreedom.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfFreedom.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfFreedom.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HAND OF FREEDOM
			if spellID == 1022 then -- HAND OF PROTECTION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfProtection.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfProtection.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End, "%a+", RSA_String_Replace), dest)
							RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.HandOfProtection.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfProtection.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfProtection.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfProtection.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfProtection.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfProtection.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfProtection.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HAND OF PROTECTION
			if spellID == 6940 then -- HAND OF SACRIFICE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.HandOfSacrifice.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfSacrifice.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfSacrifice.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSacrifice.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HAND OF SACRIFICE
			if spellID == 1038 then -- HAND OF SALVATION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfSalvation.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfSalvation.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.HandOfSalvation.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfSalvation.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfSalvation.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfSalvation.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfSalvation.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfSalvation.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfSalvation.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HAND OF SALVATION
			if spellID == 86150 or spellID == 86657 or spellID == 86674 or spellID == 86701 then -- GUARDIAN OF ANCIENT KINGS
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.GoAK.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.GoAK.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.GoAK.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.GoAK.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.GoAK.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.GoAK.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.GoAK.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.GoAK.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.GoAK.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.GoAK.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- GUARDIAN OF ANCIENT KINGS
			if spellID == 20066 then -- REPENTANCE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.Repentance.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.Repentance.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.Repentance.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.Repentance.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Repentance.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Repentance.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Repentance.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Repentance.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Repentance.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Repentance.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- REPENTANCE
			if spellID == 53563 then -- BEACON OF LIGHT
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Paladin.Spells.Beacon.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.Beacon.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.Beacon.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Paladin.Spells.Beacon.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Beacon.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Beacon.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Beacon.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Beacon.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Beacon.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Beacon.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- BEACON OF LIGHT

			-- PRIEST
			if spellID == 64843 then -- DIVINE HYMN
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.DivineHymn.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.DivineHymn.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.DivineHymn.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.DivineHymn.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.DivineHymn.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.DivineHymn.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.DivineHymn.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.DivineHymn.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DIVINE HYMN
			if spellID == 64901 then -- HYMN OF HOPE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.HymnOfHope.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.HymnOfHope.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.HymnOfHope.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.HymnOfHope.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.HymnOfHope.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.HymnOfHope.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.HymnOfHope.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- HYMN OF HOPE			
			if spellID == 6346 then -- FEAR WARD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.FearWard.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.FearWard.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.FearWard.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.FearWard.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.FearWard.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.FearWard.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.FearWard.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.FearWard.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.FearWard.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.FearWard.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- FEAR WARD
			if spellID == 1706 then -- LEVITATE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.Levitate.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.Levitate.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.Levitate.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.Levitate.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.Levitate.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.Levitate.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.Levitate.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.Levitate.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.Levitate.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.Levitate.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- LEVITATE				
			if spellID == 9484 then -- SHACKLE UNDEAD
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.ShackleUndead.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.ShackleUndead.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.ShackleUndead.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.ShackleUndead.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.ShackleUndead.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.ShackleUndead.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.ShackleUndead.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.ShackleUndead.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SHACKLE UNDEAD				
			if spellID == 47788 then -- GUARDIAN SPIRIT
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.GuardianSpirit.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.GuardianSpirit.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.GuardianSpirit.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.GuardianSpirit.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- GUARDIAN SPIRIT
			if spellID == 33206 then -- PAIN SUPPRESSION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.PainSuppression.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.PainSuppression.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.PainSuppression.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PainSuppression.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PainSuppression.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PainSuppression.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PainSuppression.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PainSuppression.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- PAIN SUPPRESSION			
			if spellID == 10060 then -- POWER INFUSION
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End ~= "" then
					if RSA.db.profile.Priest.Spells.PowerInfusion.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.Whisper == true and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You",}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.PowerInfusion.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.PowerInfusion.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.PowerInfusion.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.PowerInfusion.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.PowerInfusion.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.PowerInfusion.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- POWER INFUSION	
			
			-- WARLOCK
			if spellID == 18647 then -- BANISH
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.Banish.Messages.End ~= "" then
					if RSA.db.profile.Warlock.Spells.Banish.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Banish.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Banish.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Banish.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Banish.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Banish.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Banish.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Banish.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- BANISH
			if spellID == 5782 then -- FEAR
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.Fear.Messages.End ~= "" then
					if RSA.db.profile.Warlock.Spells.Fear.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Fear.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Fear.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Fear.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Fear.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Fear.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Fear.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Fear.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- FEAR
			if spellID == 6358 then -- SEDUCE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest,}
				if RSA.db.profile.Warlock.Spells.Seduce.Messages.End ~= "" then
					if RSA.db.profile.Warlock.Spells.Seduce.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Seduce.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Seduce.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Seduce.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Seduce.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Seduce.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Seduce.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Seduce.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SEDUCE			
			
		end -- IF EVENT IS SPELL_AURA_REMOVED
		
		
		if event == "SPELL_STOLEN" then
			-- MAGE
			if spellID == 30449 then -- SPELLSTEAL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
				if RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start ~= "" then
					if RSA.db.profile.Mage.Spells.Spellsteal.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.Spellsteal.Whisper == true and dest ~= pName and dest ~= pName and UnitIsPlayer(dest) and UnitIsFriend(pName, dest) then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You", ["AURA"] = extraspellinfo,}
						Print_Whisper(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
					end
					if RSA.db.profile.Mage.Spells.Spellsteal.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.Spellsteal.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.Spellsteal.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.Spellsteal.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.Spellsteal.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.Spellsteal.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SPELLSTEAL					
		end -- IF EVENT IS SPELL_STOLEN
		
		
		if event == "SPELL_DISPEL" then	
			-- PRIEST
			if spellID == 527 then -- DISPEL MAGIC
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
				if RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start ~= "" then
					if RSA.db.profile.Priest.Spells.DispelMagic.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Priest.Spells.DispelMagic.Whisper == true and dest ~= pName and dest ~= pName and UnitIsPlayer(dest) and UnitIsFriend(pName, dest) then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You", ["AURA"] = extraspellinfo,}
						Print_Whisper(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
					end
					if RSA.db.profile.Priest.Spells.DispelMagic.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Priest.Spells.DispelMagic.CustomChannel.Channel)
					end
					if RSA.db.profile.Priest.Spells.DispelMagic.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Priest.Spells.DispelMagic.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Priest.Spells.DispelMagic.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Priest.Spells.DispelMagic.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Priest.Spells.DispelMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DISPEL MAGIC			
			
		
			-- WARLOCK
			if spellID == 89808 then -- SINGE MAGIC
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
				if RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.SingeMagic.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.SingeMagic.Whisper == true and dest ~= pName and dest ~= pName then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You", ["AURA"] = extraspellinfo,}
						Print_Whisper(string.gsub(RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
					end
					if RSA.db.profile.Warlock.Spells.SingeMagic.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.SingeMagic.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.SingeMagic.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.SingeMagic.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.SingeMagic.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.SingeMagic.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.SingeMagic.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SINGE MAGIC
			if spellID == 19505 then -- DEVOUR MAGIC
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
				if RSA.db.profile.Warlock.Spells.Devour.Messages.Start ~= "" then
					if RSA.db.profile.Warlock.Spells.Devour.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Devour.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.Start, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Devour.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Devour.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.Start, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Devour.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Devour.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.Start, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Devour.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.Start, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DEVOUR MAGIC			
			
		end -- IF EVENT IS SPELL_DISPEL
		
		
		if event == "SPELL_DISPEL_FAILED" then		
			if spellID == 19505 then -- DEVOUR MAGIC
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
				if RSA.db.profile.Warlock.Spells.Devour.Messages.End ~= "" then
					if RSA.db.profile.Warlock.Spells.Devour.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Devour.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Devour.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Devour.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Devour.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Devour.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Devour.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Devour.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- DEVOUR MAGIC			
		
		end -- IF EVENT IS SPELL_DISPEL_FAILED
		
		
		if event == "SPELL_MISSED" and missType ~= "IMMUNE" then
			-- MAGE
			if spellID == 2139 then -- COUNTERSPELL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = missinfo,}
				if RSA.db.profile.Mage.Spells.Counterspell.Messages.End ~= "" then
					if RSA.db.profile.Mage.Spells.Counterspell.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.Counterspell.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Mage.Spells.Counterspell.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.Counterspell.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.Counterspell.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.Counterspell.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.Counterspell.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.Counterspell.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- COUNTERSPELL
			if spellID == 30449 then -- SPELLSTEAL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				extraspellinfo = GetSpellInfo(missType)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
				if RSA.db.profile.Mage.Spells.Spellsteal.Messages.End ~= "" then
					if RSA.db.profile.Mage.Spells.Spellsteal.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.Spellsteal.Whisper == true and dest ~= pName and dest ~= pName and UnitIsPlayer(dest) and UnitIsFriend(pName, dest) then
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = "You", ["AURA"] = extraspellinfo,}
						Print_Whisper(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.End, "%a+", RSA_String_Replace), dest)
						RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["AURA"] = extraspellinfo,}
					end
					if RSA.db.profile.Mage.Spells.Spellsteal.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.Spellsteal.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.Spellsteal.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.Spellsteal.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.Spellsteal.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.Spellsteal.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.Spellsteal.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SPELLSTEAL			
			
			-- PALADIN
			if spellID == 85285 then -- REBUKE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = missinfo,}
				if RSA.db.profile.Paladin.Spells.Rebuke.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.Rebuke.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Rebuke.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Rebuke.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Rebuke.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Rebuke.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- REBUKE
			if spellID == 62124 then -- HAND OF RECKONING
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = missinfo,}
				if RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfReckoning.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.End, "%a+", RSA_String_Replace))
						end
					end

				end
			end -- HAND OF RECKONING
			if spellID == 31789 then -- RIGHTEOUS DEFENSE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = missinfo,}
				if RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End ~= "" then
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.RighteousDefense.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- RIGHTEOUS DEFENSE

			-- WARLOCK
			if spellID == 19647 then -- SPELL LOCK
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = missinfo,}
				if RSA.db.profile.Warlock.Spells.SpellLock.Messages.End ~= "" then
					if RSA.db.profile.Warlock.Spells.SpellLock.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.SpellLock.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warlock.Spells.SpellLock.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.SpellLock.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.SpellLock.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.SpellLock.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.SpellLock.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.SpellLock.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.End, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SPELL LOCK
			if spellID == 17735 then -- SUFFERING
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = missinfo,}
				if RSA.db.profile.Warlock.Spells.Suffering.Messages.End ~= "" then
					if RSA.db.profile.Warlock.Spells.Suffering.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Suffering.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.End, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warlock.Spells.Suffering.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.End, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Suffering.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Suffering.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.End, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Suffering.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.End, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Suffering.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.End, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Suffering.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.End, "%a+", RSA_String_Replace))
						end
					end

				end
			end -- SUFFERING			
			
		end -- IF EVENT IS SPELL_MISSED AND NOT IMMUNE
		
		
		if event == "SPELL_MISSED" and missType == "IMMUNE" then
			-- MAGE
			if spellID == 2139 then -- COUNTERSPELL
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = missinfo,}
				if RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune ~= "" then
					if RSA.db.profile.Mage.Spells.Counterspell.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Mage.Spells.Counterspell.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Mage.Spells.Counterspell.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune, "%a+", RSA_String_Replace), RSA.db.profile.Mage.Spells.Counterspell.CustomChannel.Channel)
					end
					if RSA.db.profile.Mage.Spells.Counterspell.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Mage.Spells.Counterspell.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Mage.Spells.Counterspell.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Mage.Spells.Counterspell.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Mage.Spells.Counterspell.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- COUNTERSPELL
			
			-- PALADIN
			if spellID == 85285 then -- REBUKE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = "Immune",}
				if RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune ~= "" then
					if RSA.db.profile.Paladin.Spells.Rebuke.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.Rebuke.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.Rebuke.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.Rebuke.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.Rebuke.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.Rebuke.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.Rebuke.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- REBUKE
			if spellID == 62124 then -- HAND OF RECKONING
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = "Immune",}
				if RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune ~= "" then
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.HandOfReckoning.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.HandOfReckoning.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.HandOfReckoning.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.HandOfReckoning.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end

				end
			end -- HAND OF RECKONING
			if spellID == 31789 then -- RIGHTEOUS DEFENSE
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = "Immune",}
				if RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune ~= "" then
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune, "%a+", RSA_String_Replace), RSA.db.profile.Paladin.Spells.RighteousDefense.CustomChannel.Channel)
					end
					if RSA.db.profile.Paladin.Spells.RighteousDefense.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Paladin.Spells.RighteousDefense.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Paladin.Spells.RighteousDefense.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- RIGHTEOUS DEFENSE

			-- WARLOCK
			if spellID == 19647 then -- SPELL LOCK
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				if missType == "MISS" then
					missinfo = "Missed"
				elseif missType ~= "MISS" then
					missinfo = "Resisted"
				end
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = missinfo,}
				if RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune ~= "" then
					if RSA.db.profile.Warlock.Spells.SpellLock.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.SpellLock.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warlock.Spells.SpellLock.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.SpellLock.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.SpellLock.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.SpellLock.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.SpellLock.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.SpellLock.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.SpellLock.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
				end
			end -- SPELL LOCK
			if spellID == 17735 then -- SUFFERING
				spellinfo = GetSpellInfo(spellID) spelllinkinfo = GetSpellLink(spellID)
				RSA_Replacements = {["SPELL"] = spellinfo, ["LINK"] = spelllinkinfo, ["TARGET"] = dest, ["MISSTYPE"] = "Immune",}
				if RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune ~= "" then
					if RSA.db.profile.Warlock.Spells.Suffering.Local == true then
						if RSA.db.profile.General.Local.RaidWarn == true then
							Print_Self_RW(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.General.Local.Chat == true then
							Print_Self(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.Warlock.Spells.Suffering.Whisper == true then
						Print_Whisper(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune, "%a+", RSA_String_Replace), dest)
					end
					if RSA.db.profile.Warlock.Spells.Suffering.CustomChannel.Enabled == true then
						Print_Channel(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune, "%a+", RSA_String_Replace), RSA.db.profile.Warlock.Spells.Suffering.CustomChannel.Channel)
					end
					if RSA.db.profile.Warlock.Spells.Suffering.Smart.Say == true then
						Print_Say(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune, "%a+", RSA_String_Replace))
					end
					if RSA.db.profile.General.Smart.RaidParty == true then
						if RSA.db.profile.Warlock.Spells.Suffering.Smart.RaidParty == true then
							Print_Raid_Smart(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end
					if RSA.db.profile.General.Smart.RaidParty == false then
						if RSA.db.profile.Warlock.Spells.Suffering.Party == true then
							Print_Party(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune, "%a+", RSA_String_Replace))
						end
						if RSA.db.profile.Warlock.Spells.Suffering.Raid == true then
							Print_Raid(string.gsub(RSA.db.profile.Warlock.Spells.Suffering.Messages.Immune, "%a+", RSA_String_Replace))
						end
					end

				end
			end -- SUFFERING			


		end -- IF EVENT IS SPELL_MISSED AND IS IMMUNE
		
	end -- IF SOURCE IS PLAYER

end) -- END ENTIRELY
CombatLogMonitor:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

----------------------------------
---- Spell Reminder Functions ----
----------------------------------
--[[ Detect what talent spec we are ]]--
	local numTalents, maxTemp, returnIndex
	local tt = {}
function RSA_GetSpec() -- GetPrimarySpecInfo(player) gets player's talent spec.
	numTalents = 0
	tt = wipe(tt)
	local name, iconTexture, pointsSpent, background
	local level = UnitLevel("player");
	local hasSpec = not ( level > 0 and level < 10 )
	for i = 1, GetNumTalentTabs() do
	local name, iconTexture, pointsSpent, background = GetTalentTabInfo(i)
	if numTalents <= pointsSpent then
		numTalents = pointsSpent
		tt[i] = {name, iconTexture, pointsSpent, background}
		returnIndex = i
	end
	end
	-- returns name, iconTexture, pointsSpent, background
	if hasSpec and GetNumTalentTabs() > 0 then
	return tt[returnIndex][1] -- Spec Name
	--, tempTable[returnIndex][2], tempTable[returnIndex][3], tempTable[returnIndex][4]
	end
end

--[[ Spell Reminder ]]--
local ReminderTimeElapsed = 0.0
RSA_Reminder = CreateFrame("Frame", "RSA:R")
local function Reminder(self, elapsed)
	if RSA.db.profile.General.Class == "DEATHKNIGHT" then -- Check Class, Set the Spell we're reminding about.
		ReminderSpell = RSA.db.profile.DeathKnight.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "DRUID" then
		ReminderSpell = RSA.db.profile.Druid.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "HUNTER" then
		ReminderSpell = RSA.db.profile.Hunter.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "MAGE" then
		ReminderSpell = RSA.db.profile.Mage.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PALADIN" then
		ReminderSpell = RSA.db.profile.Paladin.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PRIEST" then
		ReminderSpell = RSA.db.profile.Priest.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "ROGUE" then
		ReminderSpell = RSA.db.profile.Rogue.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "SHAMAN" then
		ReminderSpell = RSA.db.profile.Shaman.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARLOCK" then
		ReminderSpell = RSA.db.profile.Warlock.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARRIOR" then
		ReminderSpell = RSA.db.profile.Warrior.Reminders.SpellName
	end
	if ReminderSpell == "" then return end
	if RSA.db.profile.Reminders.DisableInPvP == true and UnitIsPVP("player") then return end
	ReminderTimeElapsed = ReminderTimeElapsed + elapsed
	if ReminderTimeElapsed < RSA.db.profile.Reminders.RemindInterval then return end
	ReminderTimeElapsed = ReminderTimeElapsed - floor(ReminderTimeElapsed)
	local name = UnitBuff("player", ReminderSpell)
	if name == ReminderSpell then
		RSA_Reminder:SetScript("OnUpdate", nil)
	end
	if UnitIsDeadOrGhost("player") == 1 then return end
	if RSA.db.profile.Reminders.EnableInSpec1 == true then
		if GetActiveTalentGroup("player") == 1 then
			if RSA.db.profile.Reminders.RemindChannels.Chat == true then
				Print_Self(ReminderSpell .. " is Missing!")
			end
			if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
				Print_Self_RW(ReminderSpell .. " is Missing!")
			end
		end
	end
	if RSA.db.profile.Reminders.EnableInSpec2 == true then
		if GetActiveTalentGroup("player") == 2 then
			if RSA.db.profile.Reminders.RemindChannels.Chat == true then
				Print_Self(ReminderSpell .. " is Missing!")
			end
			if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
				Print_Self_RW(ReminderSpell .. " is Missing!")
			end
		end
	end
end

RSA_Monitor = CreateFrame("Frame", "RSA:M")
local MonitorTimeElapsed = 0.0
local function Monitor(self, elapsed)
	MonitorTimeElapsed = MonitorTimeElapsed + elapsed
	if MonitorTimeElapsed < RSA.db.profile.Reminders.CheckInterval then return end
	MonitorTimeElapsed = MonitorTimeElapsed - floor(MonitorTimeElapsed)
	if RSA.db.profile.General.Class == "DEATHKNIGHT" then -- Check Class, Set the Spell we're reminding about.
		ReminderSpell = RSA.db.profile.DeathKnight.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "DRUID" then
		ReminderSpell = RSA.db.profile.Druid.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "HUNTER" then
		ReminderSpell = RSA.db.profile.Hunter.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "MAGE" then
		ReminderSpell = RSA.db.profile.Mage.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PALADIN" then
		ReminderSpell = RSA.db.profile.Paladin.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PRIEST" then
		ReminderSpell = RSA.db.profile.Priest.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "ROGUE" then
		ReminderSpell = RSA.db.profile.Rogue.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "SHAMAN" then
		ReminderSpell = RSA.db.profile.Shaman.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARLOCK" then
		ReminderSpell = RSA.db.profile.Warlock.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARRIOR" then
		ReminderSpell = RSA.db.profile.Warrior.Reminders.SpellName
	end
	if ReminderSpell == "" then return end
	local name = UnitBuff("player", ReminderSpell)
	if name ~= ReminderSpell then
		RSA_Reminder:SetScript("OnUpdate", Reminder)
	end
end
RSA_Monitor:SetScript("OnUpdate", Monitor)